;****************************************
;
;	 "SAUCER" - A New Spectrum Game
;
;   Started On The 4th September 2006
;
;
;	(C) 2006 Frobush / Jonathan Smith
;
;****************************************

;****************************************
; CONTENDED INCLUDE FILE...
;****************************************

; RDPortASCII: 
; LogoShape:					- 0x480
; ArrowsShape:		(1*8 1*8)*2 - 0x10
; GaugeShape: 		(4*8 8*8)	- 0x100
; ScoreShape:		(6*8 3*8)   - 0x90
; ScanShape:		(11*8 3*8)  - 0x138
; CoinsShape:		(4*8 2*8)   - 0x40
; TeleShape:		(6*8 4*8)	- 0xc0
; WeapLShape:		(4*8 8*8)	- 0x100
; WeapRShape:		(3*8 7*8)	- 0xa0
; ListShape:		(2*8 2*8)	- 0x20

;****************************************
; SOUND FX DATA...
;****************************************

BangFX1:	defb	FXHISS
			defb	10,50,100,200,20,60,150,250
			defb	FXOFF

BangFX2:	defb	FXHISS
			defb	250,240,230,220,150,140,130,120
			defb	FXOFF

BangFX3:	defb	FXHISS
			defb	10,50,100,50,100,50,30,10
			defb	FXOFF

BangFX4:	defb	FXHISS
			defb	200,250,100,150,200,100,250,150
			defb	FXOFF

FireFX1:	defb	FXBOOP,030,050,FXOFF	; saucer missiles
FireFX2:	defb	FXBOOP,010,100,FXOFF
FireFX3:	defb	FXBOOP,020,150,FXOFF
FireFX4:	defb	FXBOOP,040,250,FXOFF

LinkFX1:	defb	FXBOOP,030,020,FXOFF	; link to rover

UnLinkFX1:	defb	/*FXHISS*/FXBOOP,230,FXOFF		; lift off from rover - mining ect

UnLinkFX2:	defb	/*FXBOOP*/FXHISS,220,FXOFF		; bubble burst

CoinFX:		defb	FXBEEP,30,20,18,16,15,14,12,FXOFF

TestFX:		defb	FXBOOP,200
			defb	FXGAP,99,99,99,99
			defb	FXBOOP,150
			defb	FXGAP,99,99,99
			defb	FXBOOP,200
			defb	FXGAP,99,99
			defb	FXBOOP,50
			defb	FXGAP,99
			defb	FXBOOP,100
			defb	FXOFF

RKOnFX:		defb	FXHISS
			defb	10,20,30,40
			defb	FXGAP
			defb	99,99,99,99
			defb	FXHISS
			defb	10,40,60,80
			defb	FXGAP
			defb	99,99,99,99
			defb	FXHISS
			defb	10,80,120,160
			defb	FXGAP
			defb	99,99,99,99
			defb	FXHISS
			defb	10,160,240,255
			defb	FXOFF

RKClickFX:	defb	FXHISS
			defb	250,100,50,10
			defb	FXGAP
			defb	99,99,99,99
			defb	FXHISS
			defb	50,100,250
			defb	100,50,10
			defb	50,100,250
			defb	100,50,10
			defb	50,100,250
			defb	FXOFF

;****************************************
; KEYBOARD...
;****************************************
; port, ascii key values

RDPortASCII: 
			defb	ROWRB,1,2			; 1 = SPACE 2 = SYMBOL SHIFT
			defs	"MNB"
			defb	ROWRMB,3			; 3 = ENTER
			defs	"LKJH"
  			defb	ROWRMT
			defs	"POIUY"
			defb	ROWRT
			defs	"09876"
			defb	ROWLT
			defs	"12345"
			defb	ROWLMT
			defs	"QWERT"
			defb	ROWLMB
			defs	"ASDFG"
			defb	ROWLB,4				; 4 = CAPS SHIFT
			defs	"ZXCV"

;****************************************
; TEXT TABLES...
;****************************************

RKExtra:	defw	RKSPText
			defw	RKSSText
			defw	RKENText
			defw	RKCSText

; [ = space
; \ = .
; ^	= (
; _	= )

RKBlobText: defs	"X"
			defb	0

RKSPText:	defs	"SPACE"
			defb	0
RKSSText:	defs	"SYMBOL[SHIFT"
			defb	0
RKENText:	defs	"ENTER"
			defb	0
RKCSText:	defs	"CAPS[SHIFT"
			defb	0

MenuText:	defb	8*14 + 0, 8*12
			defs	"SELECT"
			defb	0
			defb	8*11 + 0, 8*14
			defs	"1\[KEYBOARD"
			defb	0
			defb	8*11 + 0, 8*15
			defs	"2\[KEMPSTON[JOYSTICK"
			defb	0
			defb	8*11 + 0, 8*16
			defs	"3\[SINCLAIR[JOYSTICK"
			defb	0
			defb	8*11 + 0, 8*17
			defs	"4\[CURSOR[KEYS"
			defb	0
			defb	8*11 + 0, 8*18 + 4
			defs	"5\[REDEFINE[KEYS"
			defb	0
			defb	8*11 + 0, 8*20
			defs	"6\[INSTRUCTIONS"
			defb	0,0

CopyrightText:
			defb	8*11 + 4,8*9
			defs	"V[1\17[^3\11\2006_"
			defb	0
			defb	8*8, 8*23
			defs	"^C_[2006[SHORTEN[SUITE[SOFTWARE"
			defb	0,0

RKText:
			defb	8*11 + 4, 8*12
			defs	"SELECT[THE[KEY[FOR"
			defb	0
			defb	RKMENUX - 12, 8*14
			defs	"UP[[]"
			defb	0
			defb	RKMENUX - 20, 8*15
			defs	"DOWN[[]"
			defb	0
			defb	RKMENUX - 20, 8*16
			defs	"LEFT[[]"
			defb	0
			defb	RKMENUX - 24, 8*17
			defs	"RIGHT[[]"
			defb	0
			defb	RKMENUX - 56/*20*/, 8*18
			defs	"FIRE[BUTTON[1[[]"
			defb	0
			defb	RKMENUX - 56, 8*19
			defs	"FIRE[BUTTON[2[[]"
			defb	0
			defb	RKMENUX - 24, 8*20
			defs	"PAUSE[[]"
			defb	0,0

;****************************************
; SHAPE TABLES...
;****************************************

StatusShapes:

			defw	0x7080				; xxyy
			defw	0x0440				; xxyy
			defw	GaugeShape			; data
			defw	0x90a0				; score
			defw	0x0618
			defw	ScoreShape
			defw	0x08a8				; crystal scanner
			defw	0x0d18
			defw	ScanShape
			defw	0xa090				; coins
			defw	0x0410
			defw	CoinsShape
			defw	0x3088				; monitor
			defw	0x0620
			defw	TeleShape

			defw	0xc080				; weapon l
			defw	0x0440
			defw	WeapLShape

			defw	0xe088				; weapon r
			defw	0x0338
			defw	WeapRShape


			defw	ROVLOCY * 8 + 0x6800	; rover locators
			defw	0x0108
			defw	ArrowsShapeL
			defw	ROVLOCY * 8 + 0x9000
			defw	0x0108
			defw	ArrowsShapeR
			defw	BOMLOCY * 8 + 0x6800	; bomb locators
			defw	0x0108
			defw	ArrowsShapeL
			defw	BOMLOCY * 8 + 0x9000
			defw	0x0108
			defw	ArrowsShapeR
			defw	SPRLOCY * 8 + 0x6800	; spare locators
			defw	0x0108
			defw	ArrowsShapeL
			defw	SPRLOCY * 8 + 0x9000
			defw	0x0108
			defw	ArrowsShapeR

			defb	0xff				; terminate with 0xff

;****************************************
; ATTRIBUTE TABLES...
;****************************************

TeleAttr:	defb	7*PAPER+6+BRIGHT,5*PAPER+4+BRIGHT
			defb	3*PAPER+2+BRIGHT,1*PAPER+0+BRIGHT

AttrARovB:	defb	0					; in rover
			defb	BLUE + BRIGHT
			defb	BLUE + BRIGHT

AttrARovR:	defb	0					; rover is right of you
			defb	BLUE + BRIGHT
			defb	RED * PAPER + BLUE + BRIGHT
AttrARovL:	defb	RED + BRIGHT		; rover is left of you
			defb	RED * PAPER + BLUE + BRIGHT
			defb	BLUE + BRIGHT
			defb	0

AttrABomR:	defb	0					; bomb is right of you
			defb	BLUE + BRIGHT
			defb	YELLOW * PAPER + BLUE + BRIGHT
AttrABomL:	defb	YELLOW + BRIGHT		; bomb is left of you
			defb	YELLOW * PAPER + BLUE + BRIGHT
			defb	BLUE + BRIGHT
			defb	0

AttrASprR:	defb	0					; ? is right of you
			defb	BLUE + BRIGHT
			defb	GREEN * PAPER + BLUE + BRIGHT
AttrASprL:	defb	GREEN + BRIGHT		; ? is left of you
			defb	GREEN * PAPER + BLUE + BRIGHT
			defb	BLUE + BRIGHT
			defb	0

AttrStrBonus:
			defw	WhiteFlashTab
			defb	7-3,6
			defs	"PLAYED"
			defb	0

AttrStrHurry:
			defw	TartanFlashTab
			defb	7+3,6
			defs	"OOF"
			defb	0

AttrStrBang:
			defw	RedFlashTab
			defb	8,6
			defs	"BOOM"
			defb	0

AttrStrDropIt:
			defw	GreenFlashTab
			defb	8,6
			defs	"TEST"
			defb	0

RedFlashTab:
			defb	RED * PAPER + RED + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT
			defb	RED * PAPER + RED + BRIGHT

GreenFlashTab:
			defb	GREEN * PAPER + GREEN + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT
			defb	GREEN * PAPER + GREEN + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT

WhiteFlashTab:
			defb	BLUE * PAPER + BLUE + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT
			defb	BLUE * PAPER + BLUE + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT

TartanFlashTab:
			defb	MAGENTA * PAPER + MAGENTA + BRIGHT
			defb	BLUE * PAPER + BLUE + BRIGHT
			defb	RED * PAPER + RED + BRIGHT
			defb	CYAN * PAPER + CYAN + BRIGHT

;****************************************
; for game...

AttrBoxesMain:
			defb	0 * PAPER + BLACK + BRIGHT		; attribute
			defw	0x2010							; xhi,ylo size
			defw	0x00 * 0x20 + ATTRADDR + 0x00	; attribute screen address

			defb	WINDOWATTR						; play area
			defw	0x1c10	
			defw	0x00 * 0x20 + ATTRADDR + 0x02

;			defb    0 * PAPER + BLUE + BRIGHT		; status top line
;			defw	0x2001
;			defw	0x10 * 0x20 + ATTRADDR + 0x00
			defb    0 * PAPER + BLUE + BRIGHT		; status area
			defw	0x2008
			defw	0x10 * 0x20 + ATTRADDR + 0x00

			defb    0 * PAPER + BRIGHT				; remove locators!
			defw	0x0103
			defw	0x11 * 0x20 + ATTRADDR + 13
			defb    0 * PAPER + BRIGHT
			defw	0x0103
			defw	0x11 * 0x20 + ATTRADDR + 18


;			defb    0 * PAPER + BLUE + BRIGHT		; energy gauges
;			defw	0x0408
;			defw	0x10 * 0x20 + ATTRADDR + 14
			defb    BLUE * PAPER + CYAN + BRIGHT
			defw	0x0205
			defw	0x11 * 0x20 + ATTRADDR + 15
			defb    BLUE * PAPER + WHITE + BRIGHT
			defw	0x0201
			defw	0x16 * 0x20 + ATTRADDR + 15

;			defb    0 * PAPER + BLUE + BRIGHT		; score gauge
;			defw	0x0603
;			defw	0x14 * 0x20 + ATTRADDR + 18
			defb    0 * PAPER + WHITE + BRIGHT
			defw	0x0401
			defw	0x15 * 0x20 + ATTRADDR + 19

			defb    1 * PAPER + CYAN + BRIGHT		; crystal scanner
			defw	0x0c01
			defw	22 * 0x20 + ATTRADDR + 2
			defb    0 * PAPER + WHITE + BRIGHT
			defw	0x0201
			defw	22 * 0x20 + ATTRADDR + 2 + 5

			defb    0 * PAPER + YELLOW + BRIGHT		; coin gauge
			defw	0x0101
			defw	19 * 0x20 + ATTRADDR + 21
			defb    0 * PAPER + WHITE + BRIGHT
			defw	0x0201
			defw	19 * 0x20 + ATTRADDR + 22

			defb	0

; for menu...

AttrBoxesMenu:
			defb	0 * PAPER + LOGC + BRIGHT		; attribute
			defw	0x2006							; xhi,ylo size
			defw	0x02 * 0x20 + ATTRADDR + 0x00	; attribute screen address

			defb	LOGC * PAPER + WHITE			; stripes
			defw	0x0401	
			defw	0x06 * 0x20 + ATTRADDR + 0x00
			defb	LOGC * PAPER + WHITE
			defw	0x0401	
			defw	0x03 * 0x20 + ATTRADDR + 0x1c

			defb	0 * PAPER + WHITE				; version
			defw	0x2001
			defw	0x09 * 0x20 + ATTRADDR + 0x00

			defb	0 * PAPER + WHITE + BRIGHT
			defw	0x2001	
			defw	0x0c * 0x20 + ATTRADDR + 0x00

			defb	0 * PAPER + WHITE + BRIGHT		; 1 to 5
			defw	0x2005	
			defw	0x0d * 0x20 + ATTRADDR + 0x00

			defb	0 * PAPER + WHITE				; redef / instruct
			defw	0x2003	
			defw	0x12 * 0x20 + ATTRADDR + 0x00
						
			defb    0 * PAPER + LOGC + BRIGHT		; (c)
			defw	0x2001
			defw	0x17 * 0x20 + ATTRADDR + 0x00

			defb	0

; for redefinable keys menu...

AttrBoxesRK:
			defb	0 * PAPER + WHITE + BRIGHT		; press keys
			defw	0x2003	
			defw	0xa * 0x20 + ATTRADDR + 0x00

			defb	0 * PAPER + WHITE				; udlrf text
			defw	0x1008	
			defw	0xd * 0x20 + ATTRADDR + 0x00

			defb	0 * PAPER + WHITE + BRIGHT		; ?????
			defw	0x1008	
			defw	0xd * 0x20 + ATTRADDR + 0x10

			defb	0

TestCard:	defb	WHITE * PAPER + WHITE + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT
			defb	WHITE * PAPER + WHITE + BRIGHT
			defb	YELLOW * PAPER + YELLOW + BRIGHT
			defb	YELLOW * PAPER + YELLOW + BRIGHT
			defb	YELLOW * PAPER + YELLOW + BRIGHT
			defb	YELLOW * PAPER + YELLOW + BRIGHT
			defb	CYAN * PAPER + CYAN + BRIGHT
			defb	CYAN * PAPER + CYAN + BRIGHT
			defb	CYAN * PAPER + CYAN + BRIGHT
			defb	CYAN * PAPER + CYAN + BRIGHT
			defb	GREEN * PAPER + GREEN + BRIGHT
			defb	GREEN * PAPER + GREEN + BRIGHT
			defb	GREEN * PAPER + GREEN + BRIGHT
			defb	GREEN * PAPER + GREEN + BRIGHT
			defb	MAGENTA * PAPER + MAGENTA + BRIGHT
			defb	MAGENTA * PAPER + MAGENTA + BRIGHT
			defb	MAGENTA * PAPER + MAGENTA + BRIGHT
			defb	MAGENTA * PAPER + MAGENTA + BRIGHT
			defb	RED * PAPER + RED + BRIGHT
			defb	RED * PAPER + RED + BRIGHT
			defb	RED * PAPER + RED + BRIGHT
			defb	RED * PAPER + RED + BRIGHT
			defb	BLUE * PAPER + BLUE + BRIGHT
			defb	BLUE * PAPER + BLUE + BRIGHT
			defb	BLUE * PAPER + BLUE + BRIGHT
			defb	BLUE * PAPER + BLUE + BRIGHT
			defb	BLACK * PAPER + BLACK + BRIGHT
			defb	BLACK * PAPER + BLACK + BRIGHT
			defb	BLACK * PAPER + BLACK + BRIGHT
			defb	BLACK * PAPER + BLACK + BRIGHT

;****************************************
; LOGOS and STATUS STUFF...
;****************************************
; saucer menu page logo
; 24 * (6*8) - 0x480

LogoShape: 
	defb	  0,  0, 15,252,  0,  1,255,128
	defb	  0, 63,224,  7,252,  0,  1,255
	defb	128,  0, 63,240,  0,  0, 63,240
	defb	  0,  0,120,  7,  0, 31,  0,248
	defb	  0,224, 48, 12,  7,  0, 31,  0
	defb	224,  3,224, 30,  0,  1,224, 28
	defb	  0,  0,192,  1,128,112,  0, 14
	defb	  1,128, 28, 56,  1,128,112,  0
	defb	 48, 14,  0,  3,192,  7,  0,  4
	defb	  0,  3,128,  0,192,192,  0,  3
	defb	  3,  0,  4, 32,  0,192,192,  0
	defb	 24, 24,  0,  0, 96, 12,  0,  2
	defb	  0,  6,  0,  0, 67,128,  0,  1
	defb	194,  0,  6, 96,  0, 67,128,  0
	defb	  8,112,  0,  0, 56, 24,  0,  2
	defb	  0, 12,  3,240,102,  0,255,  0
	defb	102, 15,131,193,240,102,  0,254
	defb	 12,192, 31,224, 14, 48, 15,195
	defb	  0, 24, 31,248, 44,  7,255,224
	defb	 52, 31,193,131,248, 44,  7,255
	defb	  5,128,255,252,  3, 96,127,225
	defb	  0, 16, 63,252, 56, 31,255,240
	defb	 28, 63,225,135,252, 56, 15,255
	defb	135,  1,255,255,  1,192,255,241
	defb	  0, 48,127,252, 48, 63,255,252
	defb	 12, 63,225,135,252, 48, 63,255
	defb	134,  7,255,255,129,131,255,241
	defb	  0, 96,255,252, 48,127,255,254
	defb	 12, 63,225,135,252, 48,127,255
	defb	134, 15,255,255,193,  7,255,241
	defb	  0, 65,255,252, 32,255,255,255
	defb	  4, 63,225,135,252, 32,255,255
	defb	132, 31,255,255,224,  7,255,241
	defb	  0, 65,255,252,  1,255,255,255
	defb	128, 63,225,135,252,  1,255,255
	defb	128, 63,255,255,240, 15,255,241
	defb	  0,195,255,248,  3,255,255,255
	defb	128, 63,225,135,252,  1,255,255
	defb	  8,127,255,255,240, 31,255,225
	defb	  0,131,255,224,  3,255,255,255
	defb	192, 63,225,135,252,  3,255,254
	defb	  0,127,255,255,240, 31,255,193
	defb	  0,135,255,  0,  7,255,195,255
	defb	224, 63,225,135,252,  7,255,192
	defb	  0,255,248,127,224, 31,252,  1
	defb	  0,135,254,  0,  7,255,  0,255
	defb	224, 63,225,135,252,  7,255,  0
	defb	  0,255,224,255,224, 63,240,  1
	defb	  0,135,252,  0,  7,254,  0,127
	defb	224, 63,225,135,252,  7,254,  0
	defb	  0,255,193,255,192, 63,240,  1
	defb	  0,135,252,  0, 15,252,  0, 63
	defb	240, 63,225,135,252, 15,252,  0
	defb	  1,255,131,255,128, 63,224,  1
	defb	  0,135,252,  0, 15,252,  0, 63
	defb	240, 63,225,135,252, 15,252,  0
	defb	  1,255,135,255,  0, 63,224,  1
	defb	  0,135,252,  0, 15,248,  0, 31
	defb	240, 63,225,135,252, 15,248,  0
	defb	  1,255, 15,254,  0, 63,224,  3
	defb	  0,135,252,  0, 15,248,  0, 31
	defb	240, 63,225,135,252, 15,248,  0
	defb	  1,255, 15,252,  0, 63,224,  2
	defb	  0,135,252,  0, 15,248,  0, 31
	defb	240, 63,225,135,252, 15,248,  0
	defb	 33,255, 15,248,  0, 63,224,  2
	defb	  0,135,252,  1, 15,248,  0, 31
	defb	240, 63,225,135,252, 15,248,  0
	defb	225,255,  7,240,  0, 63,224,  4
	defb	  7,135,252,  7, 15,248, 24, 31
	defb	240, 63,225,135,252, 15,252, 31
	defb	161,255,131,192,  0, 63,224, 28
	defb	 28,  7,252, 61, 15,252,  0, 31
	defb	240, 63,224,  7,252, 15,252,  0
	defb	225,255,128,  0,  4, 63,225,240
	defb	 48,  7,252, 33,  7,254,  0, 31
	defb	240, 63,240, 15,252,  7,254,  0
	defb	 96,255,192,  0, 12, 63,225,  0
	defb	 96, 15,252, 33,  7,254,  0, 31
	defb	240, 63,240, 15,252,  7,255,  0
	defb	  0,255,224,  0, 28, 63,225,  0
	defb	 64, 31,252, 33,  7,255,128, 31
	defb	240, 31,252, 63,248,  7,255,192
	defb	  0,255,248,  0, 28, 63,225,  0
	defb	192,255,248, 33,  3,255,240, 31
	defb	240, 31,255,255,248,  3,255,254
	defb	  0,127,255,254, 12, 63,225,  0
	defb	131,255,248, 33,  3,255,252, 31
	defb	240, 31,255,255,248,  1,255,255
	defb	  0, 63,255,255,  4, 63,225,  0
	defb	135,255,240, 33,  1,255,254, 31
	defb	240, 15,255,255,240,  1,255,255
	defb	128, 63,255,255,132, 63,225,  0
	defb	135,255,240, 33,128,255,254, 31
	defb	240,  7,255,255,224,  0,255,255
	defb	128, 31,255,255,132, 63,225,  0
	defb	135,255,224, 32,128,127,254, 31
	defb	240,  3,255,255,192,  0,127,255
	defb	128, 15,255,255,132, 63,225,  0
	defb	135,255,192, 32,128, 63,254, 31
	defb	240,  1,255,255,128,  0, 63,255
	defb	128,  7,255,255,132, 63,225,  0
	defb	135,255,128, 32,128, 31,254, 31
	defb	240,  0,255,255,  0,  0, 15,255
	defb	128,  1,255,255,132, 63,225,  0
	defb	131,254,  0, 96,192,  7,252, 15
	defb	224,  0,127,254,  0, 64,  7,255
	defb	  8,  0,255,255, 12, 31,193,  0
	defb	129,248,  0, 64, 64,  0,248,  7
	defb	192,  0, 15,240,  0, 64,  0,254
	defb	  0,  0, 31,254,  4, 15,129,  0
	defb	128,  0,  0, 64, 96,  0,  0,  0
	defb	  0,  0,  0,  0,  0,224,  0,  0
	defb	  4,  0,  0,  0,  4,  0,  1,  0
	defb	128,  0,  0,192, 48,  0,  0,  0
	defb	  0,128,  0,  0,  1,176,  0,  0
	defb	  6,  0,  0,  0,  4,  0,  1,  0
	defb	128,  0,  1,128, 16,  0,  0,  0
	defb	  0,128,  0,  0,  1, 16,  0,  0
	defb	  6,  0,  0,  0,  4,  0,  1,  0
	defb	128,  0,  1,  0, 24,  0,  0,  0
	defb	  0,192,  0,  0,  3, 24,  0,  0
	defb	  7,  0,  0,  0,  4,  0,  1,  0
	defb	128,  0,  3,  0, 12,  0,  0,  0
	defb	  0,224,  0,  0,  6, 12,  0,  0
	defb	  5,128,  0,  0,  4,  0,  1,  0
	defb	192,  0,  6,  0,  6,  0,  0,  0
	defb	  1,176,  0,  0, 12,  6,  0,  0
	defb	 12,224,  0,  0, 14,  0,  3,  0
	defb	 64,  0, 12,  0,  3,128,  0,  0
	defb	  1, 24,  0,  0, 24,  3,128,  0
	defb	  8, 48,  0,  0, 26,  0,  6,  0
	defb	 96,  0, 56,  0,  0,192,  0,  0
	defb	  3, 14,  0,  0,112,  0,192,  0
	defb	 24, 24,  0,  0, 19,  0,  4,  0
	defb	 48,  0, 96,  0,  0,112,  0, 64
	defb	 14,  3,128,  1,192,  0,112,  0
	defb	 48, 15,  0,  0,113,128, 28,  0
	defb	 28,  3,192,  0,  0, 31,  1,240
	defb	 24,  0,240,  7,  0,  0, 31,  0
	defb	224,  1,224,  0,192,224, 48,  0
	defb	  7,254,  0,  0,  0,  1,255, 31
	defb	240,  0, 63,252,  0,  0,  1,255
	defb	128,  0, 63,255,128, 63,224,  0

;****************************************

ArrowsShapeL:
	defb	  0,  1,  3,  7,  7,  3,  1,  0
ArrowsShapeR:
	defb	  0,128,192,224,224,192,128,  0

GaugeShape:
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  1,255,255,128
	defb	  3,  0,  0,192,  6, 60, 60, 96
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,195,195,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,195,195,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,195,195,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,195,195,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,129,129,112, 14,  0,  0,112
	defb	 14,195,195,112,254,  0,  0,127
	defb	254,129,129,127,174,  0,  0,117
	defb	  6,129,129, 96, 14,  0,  0,112
	defb	142,129,129,124,206,  0,  0,126
	defb	102,195,195,127,118,  0,  0,103
	defb	118,129,129,115,118,  0,  0,115
	defb	118,129,129,115,118,  0,  0,115
	defb	118,129,129,115,102,  0,  0,115
	defb	198,126,126, 99,131,  0,  0,195
	defb	  1,255,255,131,  0,  0,  0,  3
	defb	  0,101, 84,  7,  0,127, 15,143
	defb	  0, 60,  7,254,  0,  0,  1,252

ScoreShape:
	defb	  0,  0,  1,255,255,255,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0, 12
	defb	  0,  0,  0,  0,  0, 28,  0,  0
	defb	  0,  0,  0, 12,  0,  0,  0,  0
	defb	  0, 28,  0,  0,  7,255,255,255
	defb	255,192, 14,  0,  0,  0,  0,224
	defb	 28,  0,  0,  0,  0,112,220, 68
	defb	 68, 68, 68,112,220,170,170,170
	defb	170,112, 92,170,170,170,170,112
	defb	 28,170,170,170,170,112, 28, 68
	defb	 68, 68, 68,112, 28,  0,  0,  0
	defb	  0,112, 14,  0,  0,  0,  0,224
	defb	  7,255,255,255,255,192,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0

ScanShape:
	defb	  0,  0,  0,  0,  0,  6,  0,  0
	defb	  0,  0, 96,  0,  0,  0,  0,  0
	defb	  0,  0,  3,255,255,255,255,192
	defb	 15,255,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0, 63,255,  0
	defb	  0,  0,  0,  0,  0, 40,  0,  0
	defb	  0,  0,122,170,  0,  0,  0,  0
	defb	  0,  0, 24,  0,  0,  0,  0,120
	defb	  0,  0,  0,  0,  0,  0,  0, 56
	defb	  0,  0,  0,  0,240,  0,  1,255
	defb	255,255,255,255,255,255,255,255
	defb	255,255,255,  3,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  1,  0,  0,  0
	defb	  6, 42,170,128,128,128,  1,128
	defb	  1,  1,  1, 85, 84, 14,128,128
	defb	128,128,128,  0,  0,  1,  1,  1
	defb	  1,  1, 14,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0, 14
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0, 14,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0, 14,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0, 14,128
	defb	128,128,128,128,  0,  0,  1,  1
	defb	  1,  1,  1,  6, 42,170,128,128
	defb	128,  1,128,  1,  1,  1, 85, 84
	defb	  3,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  1,255,255
	defb	255,255,255,255,255,255,255,255
	defb	255,255,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0

CoinsShape:
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  3,255,255,255,  7,  0,  0,  0
	defb	 14,  0,  0,  0, 14, 44,  0, 68
	defb	 14, 94, 40,170, 14, 94, 16,170
	defb	 14, 94, 40,170, 14, 44,  0, 68
	defb	 14,  0,  0,  0,  7,  0,  0,  0

TeleShape:
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  3,255,255,255
	defb	255,192,  6,  0,  0,  0,  0, 96
	defb	  6, 15, 15, 15, 15, 96, 14, 15
	defb	 15, 15, 15,112, 14, 15, 15, 15
	defb	 15,112, 14, 15, 15, 15, 15,112
	defb	 14, 15, 15, 15, 15,112, 14, 15
	defb	 15, 15, 15,112, 14, 15, 15, 15
	defb	 15,112, 14, 15, 15, 15, 15,112
	defb	 14, 15, 15, 15, 15,112, 14, 15
	defb	 15, 15, 15,112, 14, 15, 15, 15
	defb	 15,112, 14, 15, 15, 15, 15,112
	defb	 14, 15, 15, 15, 15,112, 14, 15
	defb	 15, 15, 15,112, 14, 15, 15, 15
	defb	 15,112, 14, 15, 15, 15, 15,112
	defb	 14, 15, 15, 15, 15,112, 14, 15
	defb	 15, 15, 15,112, 14, 15, 15, 15
	defb	 15,112, 14, 15, 15, 15, 15,112
	defb	 14, 15, 15, 15, 15,112, 14, 15
	defb	 15, 15, 15,112, 14, 15, 15, 15
	defb	 15,112,  6, 15, 15, 15, 15, 96

WeapLShape:
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  1,255,255,128,  3,  0,  0,192
	defb	  6,  0,  0, 96, 14,  0,  0,112
	defb	 14,  0,  0,112, 14,  0,  0,112
	defb	 14,  0,  0,112, 14,  0,  0,112
	defb	 14,  0,  0,113, 14,  0,  0,115
	defb	 14,  0,  0,118, 14,  0,  0,126
	defb	 14,  0,  0,126, 14,  0,  0,126
	defb	 14,  0,  0,126, 14,  0,  0,126
	defb	198,  0,  0,126,226,  0,  0,110
	defb	115,  0,  0,206,113,255,255,142
	defb	112,  0,  0, 14,112,  0,  0, 14
	defb	112,  0,  0, 14,119,224,  0, 14
	defb	119,240,  0, 14,226,184,  0,  6
	defb	192, 24,  0,  3,  0, 56,  0,  1
	defb	  0, 24,  0,  0,  0, 56,  0,  0
	defb	  0, 24,  0,  0,  0,  0,  0,  0
	defb	  1,255,255,129,  3,  0,  0,195
	defb	  6,  0,  0,102, 14,  0,  0,126
	defb	 14,  0,  0,126, 14,  0,  0,126
	defb	 14,  0,  0,126, 14,  0,  0,126
	defb	 14,  0,  0,126, 14,  0,  0,126
	defb	 14,  0,  0,126, 14,  0,  0,126
	defb	 14,  0,  0,126, 14,  0,  0,126
	defb	 14,  0,  0,126, 14,  0,  0,126
	defb	 14,  0,  0,126,  6,  0,  0,102
	defb	  3,  0,  0,195,  1,255,255,129
	defb	  0,  0,  0,  0,  0,  0, 22,  0
	defb	  0,  0, 11,255,  0,  0,  5,255
	defb	  0,  0,  2,170,  0,  0,  0,  0

WeapRShape:
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,  0,  0,  0,  0,  0,  0
	defb	  0,  0,255,255,128,  0,  0,192
	defb	  0,  0, 96,  0,  0,112,  0,  0
	defb	112,  0,  0,112,  0,  0,112,  0
	defb	  0,112,  0,  0,112,  0,  0,112
	defb	  0,  0,112,  0,  0,112,  0,  0
	defb	112,  0,  0,112,  0,  0,112,  0
	defb	  0,112,  0,  0,112,  0,  0, 96
	defb	  0,  0,192,255,255,128,  0,  0
	defb	  0,  5,  0,  0,  3,  0,  0,  7
	defb	  0,  0,255,255,128,  0,  0,192
	defb	  0,  0, 96,  0,  0,112,  0,  0
	defb	112,  0,  0,112,  0,  0,112,  0
	defb	  0,112,  0,  0,112,  0,  0,112
	defb	  0,  0,112,  0,  0,112,  0,  0
	defb	112,  0,  0,112,  0,  0,112,  0
	defb	  0,112,  0,  0,112,  0,  0, 96
	defb	  0,  0,192,255,255,128,  0,  0
	defb	  0, 44,  0,  0,248,  0,  0,240
	defb	  0,  0,160,  0,  0,  0,  0,  0


;****************************************
; END
;****************************************
