;****************************************
;
;	 "SAUCER" - A New Spectrum Game
;
;	Started On The 4th September 2006
;
;
;	(C) 2006 Frobush / Jonathan Smith
;
;****************************************

;****************************************
; DEBUG INDCLUDE FILE...
;****************************************

HEXCHARS:		equ		NUMBERCHARS		; needs to point to chr data

;****************************************

; HexWord:
; HexByte:
; BinByte:

;****************************************
; word HL = screen addr	bc = word
; byte HL = screen addr a = byte

HexWord:	ld		a,b
			ex		af,af
			ld		a,c
			call	HexByte
			ex		af,af

HexByte:	ld		c,a
			call	HexDigit
			ld		a,c
			sra		a
 			sra		a
  			sra		a
   			sra		a

HexDigit:	and		0x0f
			push	hl
			push	hl

			add		a,a
			add		a,a
			ld		l,a
			ld		h,0
			ld		d,h
			add		hl,hl
			ld		e,a
			add		hl,de

			ld		de,HEXCHARS
			add		hl,de
			pop		de

			ld		b,6
HexLoop:
			ld		a,(hl)
			ld		(de),a
			inc		e
			inc		hl
			ld		a,(hl)
			ld		(de),a
			dec		e
			inc		d
			inc		hl
			djnz	HexLoop

			pop		hl
			dec		l
			dec		l
			ret

;****************************************
; byte HL = screen addr a = byte

BinByte:
			ld		b,8
BinLoop:
			ld		c,a
			and		0x1
			push	bc
			call	HexDigit
			pop		bc
			ld		a,c
			rrca
			djnz	BinLoop
			ret

;****************************************
; DEVELOPMENT STUFF ONLY...
;****************************************
;****************************************
; DEBUG DISPLAY...
;****************************************

DebugDisplayOnce:

			ld		e,DEBUGX + 16 +80 -8		; page0 left
			ld		d,DEBUGY
			call	Pixad
			ld		a,256 - PAGE0E
			Call	HexByte

			ld		e,DEBUGX + 16 + 80 -8		; page 1 left
			ld		d,DEBUGY + 8
			call	Pixad
			ld		a,256 - PAGE1E
			Call	HexByte

			ld		e,DEBUGX + 16 + 80 -8		; page 2 left
			ld		d,DEBUGY + 16
			call	Pixad
			ld		a,256 - PAGE2E
			call	HexByte

			ld		e,DEBUGX + 16 + 80 -8		; page 3 left
			ld		d,DEBUGY + 24
			call	Pixad
			ld		a,256 - PAGE3E
			call	HexByte

			ld		e,DEBUGX + 16 + 80 -8		; page 4 left
			ld		d,DEBUGY + 32
			call	Pixad
			ld		a,256 - PAGE4E
			call	HexByte

			ld		e,DEBUGX + 48 +48 -8		; last address used
			ld		d,DEBUGY + 48
			call	Pixad
			ld		bc,ENDCODE
			Call	HexWord

			; more?

			ret


DebugDisplay:

			ld		e,DEBUGX + 80
			ld		d,DEBUGY + 0
			call	Pixad
			ld		a,(Temp)
;			ld		a,(BOMBVARS + GNO)
			Call	HexByte

			ld		e,DEBUGX + 80
			ld		d,0
			call	Pixad
			ld		bc,(TempX)
			Call	HexWord
			ld		e,DEBUGX + 80
			ld		d,8
			call	Pixad
			ld		bc,(TempY)
			Call	HexWord

			ret
/*
			ld		e,DEBUGX + 80
			ld		d,DEBUGY + 8
			call	Pixad
			ld		bc,(TempX)
			Call	HexWord

			ld		e,DEBUGX + 80
			ld		d,DEBUGY + 16
			call	Pixad
			ld		bc,(TempY)
			Call	HexWord



			ld		e,DEBUGX + 80
			ld		d,DEBUGY + 40
			call	Pixad
			ld		bc,(SPData+XNO)
			Call	HexWord

			ld		e,DEBUGX + 80
			ld		d,DEBUGY + 48
			call	Pixad
			ld		bc,(SPData+YNO)
			jp		HexWord

;			ld		e,DEBUGX + 256 - 16
; 			ld		d,DEBUGY + 48
;  			call	Pixad
;   			ld		a,(FUDLR)			; joypad
;			jp		BinByte
*/
;****************************************
; END
;****************************************
