;****************************************
;
;	 "SAUCER" - A New Spectrum Game
;
;	Started On The 4th September 2006
;
;
;	(C) 2006 Frobush / Jonathan Smith
;
;****************************************

;****************************************
; MENUS AND STUFF...
;****************************************

; DrawStatus:
; Locaters:
; Locater:
; LandRadar:
; Gauges:
; ScoreAdd:
; PrScore:
; PrCoins:
; MiniTele:
; WaitVBlankLogo:
; ClearMenu:
; FlashOption:
; WorkMenu:
; RedefineKeys:
; PauseGame:

;****************************************
; DRAW THE STATUS DISPLAY...
;****************************************

DrawStatus:
			ld		hl,StatusShapes
			call	PrintShapes

			ld		hl,16384 + 2048 + 2048 + 2 + 1 + 256
			ld		e,l
			ld		d,h
			inc		e
			ld		bc,32 - 1 - 4 - 1
			ld		(hl),0x55
			dec		l
			ld		(hl),0xaa
			ldir						; draw line below window
; more...
			ret

;****************************************
; WORK LOCATER DISPLAY...
;****************************************

Locators:	ld		a,(Loops)			; alternate rover/bomb locator
			and		3
			jr		z,LocBom
			dec		a
			jr		z,LocRov

; more here? dec a or table jump!

			ld		a,(BADDIEVARS + GNO); locate ?
			ld		bc,(BADDIEVARS + XNO)
			ld		de,SPRLOCY * 0x20 + ATTRADDR + 13
			ld		hl,SprAAts
			jr		Locator

LocRov:		ld		a,(WHEELVARS + GNO)	; locate rover
			ld		hl,(WHEELVARS + XNO)
 			ld		bc,WHEELXOFF
  			add		hl,bc
			ld		c,l
			ld		b,h
			ld		hl,RovAAts
			ld		de,ROVLOCY * 0x20 + ATTRADDR + 13
			jr		Locator

LocBom:		ld		a,(BOMBVARS + GNO)	; locate bomb
			ld		bc,(BOMBVARS + XNO)
			ld		de,BOMLOCY * 0x20 + ATTRADDR + 13
			ld		hl,BomAAts

;****************************************

Locator:	or		a					; item on screen?
			jp		m,FlashArr
		
			ld		a,(Loops)			; show which direction it is located
  			and		16+4
			jr		z,FlashArr

			push	hl
   			ld		hl,(SAUCERVARS + XNO)
			sbc		hl,bc
			ld		a,h
			pop		hl
			inc		l
			inc		l
			or		a
			jp		p,FlashArr			; left or right of you?
			inc		l
			inc		l

FlashArr:	ld		a,(hl)				; and display...
			inc		l
			ld		h,(hl)
			ld		l,a

			ldi
			ldi
			inc		e
			inc		e
			ldi
			ldi							; flash arrows
			ret

;****************************************
; LANDSCAPE RADAR...
;****************************************

LandRadar:	ld		a,(SmartDel)		; smart bombing?
			or		a
			jr		z,NormScan

			ld		a,(Rand1)			; then this FX
			ld		e,a
			ld		d,0x80
			jr		DoScan

NormScan:	ld		hl,(SAUCERVARS+XNO)	; index the landscape
			ld		de,6 * 128 - 8
			or		a
			sbc		hl,de
			call	GroundAddr
			ex		de,hl

DoScan:		ld		hl,256 * 3 + SCANADDR

			ld		a,12				; radar is 12 chrs long
LandR:		ld		b,8					; c is bit store!
			ex		af,af
CryByte:	ld		a,(de)
			inc		e
			sub		1					; it sets the carry flag!
			rl		c
			djnz	CryByte

			ld		(hl),c				; copy bits to screen (double height)
			inc		h
			ld		(hl),c
			dec		h
			inc		l
			ex		af,af
			dec		a
			jr		nz,LandR

			;*******************

			; magnify middle bits...

			ld		hl,0x300 + SCANADDR + 2
			ld		de,0x200 + SCANADDR + 2
			push	hl
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi

			pop		hl
			ld		de,0x500 + SCANADDR + 2

			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi

			ld		hl,(0x300 + SCANADDR + 5)
			ld		(0x100 + SCANADDR + 5),hl
			ld		(0x600 + SCANADDR + 5),hl
			ret

;****************************************
; WORK THE DISPLAY GAUGES...
;****************************************

Gauges:		ld		a,(Crystals)		; crystal gauge
			cp		DRILLSIZE
			jr		nc,GotAllC

			ld		e,8 * 16
			call	PrGauge

GotAllC:	ld		e,8 * 15			; drill gauge
			ld		a,(DrillDel)
			ld		c,a
			ld		a,(DrillGag)		; must wait for stuff!
			cp		c
			jr		c,BarUp
			or		a
			ret		z
			ld		d,a
			dec		a
			ld		(DrillGag),a

			ld		a,8 * 23; - 1
			sub		d
			ld		d,a
			call	Pixad
			ld		a,(hl)				; rub out gauge
			and		0xc3
			ld		(hl),a
			ret

BarUp:		ld		a,c
			ld		(DrillGag),a

PrGauge:	ld		d,a
			ld		a,8 * 23; - 1
			sub		d
			ld		d,a
			call	Pixad

			ld		a,(hl)				; draw gauge
			or		0x3c
			ld		(hl),a
			ret

;****************************************
; SCORE ROUTINES...
;****************************************

; enters with  e = index (0 to 7)  d = chr to add (0 to 9)

ScoreAdd:	ld		a,e
			add		a,Score & 0xff
			ld		l,a
			ld		h,Score / 0x100
			ld		a,d

UpScore:	add		a,(hl)
			cp		48 + 10
			jr		c,NoSc
			sub		10
			ld		(hl),a
			dec		l
			ld		a,1
			jr		UpScore

NoSc:		ld		(hl),a
			ret

;****************************************
; PRINT SCORE - NIBBLE BY NIBBLE...
;****************************************

; enters with  l = loop counter low byte

PrScore:	ld		a,l					; only dump 1 nibble per loop
			and		7
			ld		l,a
			ld		c,a
			add		a,Score & 0xff
			ld		e,a
			ld		d,Score / 0x100

			ld		a,l					; get screen addr
			srl		a
			add		a,SCOREADDR & 0xff
			ld		l,a
			ld		h,SCOREADDR / 0x100

			ld		a,0x0f
			bit		0,c
			jr		nz,LowNib
			cpl
LowNib:		ld		c,a
			cpl
			ld		b,a

			ld		a,(de)				; score digit
			sub		48

PrNib:		ld		e,a
			add		a,a
			add		a,a
			add		a,e
			add		a,NibbleChrs & 0xff
			ld		e,a
			ld		d,NibbleChrs / 0x100

			ld		a,5
NibL12:		ex		af,af				; draw nible sized chr...
			ld		a,(hl)
			and		b
			ld		(hl),a
			ld		a,(de)
			and		c	
			or		(hl)
			ld		(hl),a
			inc		e
			inc		h
			ex		af,af
			dec		a
			jr		nz,NibL12
			ret

;****************************************
; PRINT COIN TOTAL...
;****************************************

PrCoins: 	ld		a,(CoinDel)			; coin flashing?
			or		a
			jr		z,NoCoinF
			dec		a
			ld		(CoinDel),a
			cpl
			and		4
			jr		z,FlashC			; then flash coin
			ld		a,YELLOW + BRIGHT
FlashC:		ld		(19 * 0x20 + ATTRADDR + 21),a

NoCoinF:	ld		a,(Coins)

			ld		c,0xff				; convert 0 to 99 into 2 digits
FindDec:	inc		c
			sub		10
			jr		nc,FindDec

			push	af
			ld		a,c
			ld		hl,COINADDR
			ld		bc,0x0ff0
			call	PrNib				; 10's digit
			pop		af
			add		a,10
			ld		hl,COINADDR
			ld		bc,0xf00f
			jr		PrNib				; digit

;****************************************
; WORK THE MINI-MONITORS...
;****************************************

MiniTele:
			ld		a,(Loops)			; weapon monitor fx...
			ld		c,a
			and		3
			add		a,a
			add		a,WeapAttrAd & 0xff
			ld		l,a
			ld		h,WeapAttrAd / 0x100
	push	hl
			ld		e,(hl)
			inc		l
			ld		d,(hl)				; weapon monitor attr address

			ld		a,(Rand3)
			and		2
			add		a,WeapAttr & 0xff
			ld		l,a
			ld		a,(hl)				; test flicker

			ld		(de),a
			inc		e
			ld		(de),a
			ld		hl,0x20				; down line
			add		hl,de
			ld		(hl),a
			dec		l
			ld		(hl),a

			;****************

			pop		hl
			ld		a,l					; screen addresses
			add		a,8
			ld		l,a
			ld		e,(hl)
			inc		l
			ld		d,(hl)
			push de
			ld		a,c
			srl		a
			srl		a
			and		31
			add		a,a
			ld		e,a
			ld		d,0
			ld		hl,ListShape
			add		hl,de
			ex		de,hl
			pop	hl
			ld		b,8
MonTop1:	ld		a,(de)
			ld		(hl),a
			inc		l
			inc		de
			ld		a,(de)
			ld		(hl),a
			inc		h
			dec		l
			inc		de
			djnz	MonTop1
			call	DLine
			ld		b,8
MonTop2:	ld		a,(de)
			ld		(hl),a
			inc		l
			inc		de
			ld		a,(de)
			ld		(hl),a
			inc		h
			dec		l
			inc		de
			djnz	MonTop2

			;****************

			ld		a,c
			dec		a
			and		31
			cp		24

			ret		nc				; wasted cycles!


			add		a,8 * 18		; scan line on tele
			ld		d,a
			ld		e,8 * 7
			call	Pixad			; hl = screen address

			ld		a,0xf0			; colour FX
			bit		5,c
			jr		z,TeleLin
			cpl
TeleLin:	ld		c,a

			ld		a,(hl)			; scan line tracer...
			xor		c
			ld		(hl),a
			inc		l
			ld		a,(hl)
			xor		c
			ld		(hl),a
			inc		l
			ld		a,(hl)
			xor		c
			ld		(hl),a
			inc		l
			ld		a,(hl)
			xor		c
			ld		(hl),a
			ret

;****************************************

TeleColour:	ld		a,3					; colour the tele - this for now!
			ld		de,18 * 0x20 + ATTRADDR + 7
MonitAT:	ld		hl,TeleAttr
			ldi
			ldi
			ldi
			ldi
			ld		hl,0x20 - 4
			add		hl,de
			ex		de,hl
			dec		a
			jr		nz,MonitAT
			ret

;****************************************
; WAIT FOR FLYBACK AND DUMP LOGO...
;****************************************

WaitVBlankLogo:

			call	Random
			call	WaitVBlank

			ld		bc,0x1830			; image size
			ld		de,0x1020			; image position
			ld		hl,LogoShape		; image

			ld		a,(SpeedFlag)		; alternate fx and normal
			and		0x80
			jp		z,PrintShape		; draw logo

			ld		a,(Rand1);(SpeedFlag)
;			add		a,a
;			neg
			jp		PrintShapeFX		; draw logo	with FX

;****************************************
; WORK THE MAIN MENU SCREEN...
;****************************************

ClearMenu:	xor		a
			ld		c,MENUBOXYL			; xy size
			ld		b,14
			ld		hl,MENUBOXY * 0x20 + ATTRADDR + 9
			call	FillAttrBox

			xor		a
			ld		e,8*9				; xy
			ld		d,8*MENUBOXY
			ld		c,8*MENUBOXYL		; xy size
			ld		b,14
			jp		FillScreenBox			

FlashOption:
			ld		a,(SpeedFlag)		; flash the 'select' option
			and		0x20 + 0x8
			jr		z,FlashMenu
			ld		a,WHITE + BRIGHT
FlashMenu:	ld		hl,0x0c * 0x20 + ATTRADDR + 0x00
			ld		bc,0x2001
			jp		FillAttrBox

;****************************************

WorkMenu:	call	WaitVBlank			; wait for flyback
			call	ScreenOff

			ld		hl,CopyrightText	; display the menu text
			call	NibblePrinter

MenuBack:	ld		hl,MenuText			; display the menu text
			call	NibblePrinter

			call	WaitVBlankLogo		; wait for flyback
			ld		hl,AttrBoxesMenu
			call	FillAttrBoxes		; screen on!

;****************************************

MenuLoop:	call	WaitVBlankLogo		; wait for flyback
			call	ReadKeyStick		; read keyboard / joysticks

			call	FlashOption

			ld		a,(OldFUDLR)		; debounce
			and		FIREMASK+UPMASK+DOWNMASK+LEFTMASK+RIGHTMASK
			jr		nz,MenuLoop
			ld		a,(FUDLR)
			and		FIREMASK+UPMASK+DOWNMASK+LEFTMASK+RIGHTMASK
			jr		z,MenuLoop

			ld		c,MENUREDK			; convert the 5 bits to an index number
Key2Num:	srl		a
			jr		c,KeyFound
			dec		c
			jr		Key2Num

KeyFound:	or		a					; any bits left means multiple key presses!
			jr		nz,MenuLoop

			ld		a,c
			cp		MENUREDK			; redefine keys?
			jr		z,RedefineKeys			

			ld		(MenuSelect),a
			ret

;****************************************
; REDEFINABLE KEYS...
;****************************************

RedefineKeys:
			ld		a,FXRKON			; go sound fx
			call	GoFXForce

			xor		a
			ld		(SpeedFlag),a

			ld		hl,AKBuffer			; reset ascii key buffer
			ld		b,KEYTOTAL
CPBuffSet:	ld		(hl),a
			inc		l
			djnz	CPBuffSet

			dec		a					; -1 for 1st pass
			ld		(Duf),a				; ascii store

			call	WaitVBlankLogo		; wait for flyback
			call	ClearMenu
			ld		hl,RKText
			call	NibblePrinter

			call	WaitVBlank			; wait for flyback
			ld		hl,AttrBoxesRK
			call	FillAttrBoxes		; screen on!

			ld		b,KEYTOTAL			; number of keys to select

RKLoopGo:	ld		c,0					; for flash

RKLoop:		push	bc
			call	WaitVBlank;Logo		; wait for flyback
			call	RKReadPort			; Get Key Press / ascii
			ld		(Duf),a
			call	FlashOption
			pop		bc
			inc		c

			xor		a					; flash current selection
			call	RKBlob
			ld		a,c
			and		0x10 + 0x8
			jr		z,FlashBlob
			ld		a,93				; flash "?"
			call	RKBlob

FlashBlob:	ld		a,(Duf)
			or		a					; no key pressed
			jp		m,RKLoop
			jr		z,RKLoop

			push	af
			ld		a,FXRKCLICK			; go sound fx
			call	GoFXForce
			xor		a					; show the new key pressed
			call	RKBlob
			pop		af
			call	RKBlob

			djnz	RKLoopGo

			ld		b,50*2
RKLoop1:	push	bc
			call	WaitVBlank			; wait for flyback
			call	FlashOption
			xor		a					; stops the flashing and reset timer
			ld		(SpeedFlag),a
			pop		bc
			djnz	RKLoop1

			call	ClearMenu
			jp		MenuBack

;****************************************
; a = 0 or blob char

RKBlob:		ex		af,af

			push	bc					; print / remove the blob item
			ld		a,KEYTOTAL
			sub		b
			add		a,a
			add		a,a
			add		a,a
			add		a,8*14
			ld		d,a
			ld		e,RKMENUX + 4

			ex		af,af
			or		a
			jr		nz,PRRKBlob

			ld		bc,0x0108
			call	FillScreenBox		; rub out section
			pop		bc
			ret

PRRKBlob:	cp		5					; if not ascii then special string
			jr		nc,JustOneA
			dec		a
			add		a,a
			ld		c,a
			ld		b,0
			ld		hl,RKExtra			; space/s.shift/enter/c.shift
			add		hl,bc
			ld		c,(hl)
			inc		hl
			ld		b,(hl)
			jr		ExtraRK

JustOneA:	ld		(RKBlobText),a		; ascii value
			ld		bc,RKBlobText		; print blob item
ExtraRK:	call	NibblePrint
			pop		bc
			ret

;****************************************
; PAUSE THE GAME...
;****************************************

PauseGame:	ld		a,(OldFUDLR)		; debounce
 			and		PAUSEMASK
  			ret		nz
   			ld		a,(FUDLR)			; pause the game?
			and		PAUSEMASK
	 		ret		z

			call	WaitVBlank

			ld		a,24				; display TEST CARD
			ld		de,ATTRADDR
CardLoop:	ld		hl,TestCard
			ld		bc,32
			ldir
			dec		a
			jr		nz,CardLoop

PauseLoop:	call	WaitVBlank			; wait for flyback
			call	ReadKeyStick		; read keyboard / joysticks

			ld		a,(OldFUDLR)		; debounce
			and		PAUSEMASK
			jr		nz,PauseLoop
			ld		a,(FUDLR)			; return to game?
			and		PAUSEMASK
			jr		z,PauseLoop

			call	WaitVBlank
			ld		hl,AttrBoxesMain
			call	FillAttrBoxes		; screen on
			jp		TeleColour			; blimey!

;****************************************
; END
;****************************************
